Index: trunk/src/org/expeditee/gui/FrameUtils.java
===================================================================
--- trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1241)
+++ trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1242)
@@ -24,7 +24,11 @@
 import java.io.IOException;
 import java.io.InputStream;
+import java.lang.reflect.InvocationTargetException;
 import java.net.JarURLConnection;
+import java.net.URISyntaxException;
 import java.net.URL;
 import java.net.URLConnection;
+import java.nio.file.Path;
+import java.nio.file.Paths;
 import java.util.ArrayList;
 import java.util.Arrays;
@@ -36,8 +40,12 @@
 import java.util.LinkedList;
 import java.util.List;
+import java.util.Map;
 import java.util.jar.JarEntry;
 import java.util.jar.JarFile;
+import java.util.stream.Collectors;
 import java.util.zip.ZipEntry;
 
+import org.expeditee.agents.ExistingFramesetException;
+import org.expeditee.agents.InvalidFramesetNameException;
 import org.expeditee.auth.gui.MailBay;
 import org.expeditee.core.Colour;
@@ -67,4 +75,5 @@
 import org.expeditee.items.widgets.WidgetCorner;
 import org.expeditee.items.widgets.WidgetEdge;
+import org.expeditee.setting.Setting;
 import org.expeditee.settings.Settings;
 import org.expeditee.settings.UserSettings;
@@ -76,6 +85,6 @@
 
 	/**
-	 * The list of known start pages framesets which will have prepopulated
-	 * links in the home frame.
+	 * The list of known start pages framesets which will have prepopulated links in
+	 * the home frame.
 	 */
 	public static final String[] startPages = { "exploratorysearch", "webbrowser" };
@@ -99,17 +108,15 @@
 	private static Item _tdfcItem = null;
 
-	public static float getResponseTimeTotal()
-	{
+	public static float getResponseTimeTotal() {
 		return _ResponseTimeSum;
 	}
 
-	public static float getLastResponseTime()
-	{
+	public static float getLastResponseTime() {
 		return _LastResponse;
 	}
 
 	/**
-	 * Checks if the given top Item is above the given bottom Item, allowing for
-	 * the X coordinates to be off by a certain width...
+	 * Checks if the given top Item is above the given bottom Item, allowing for the
+	 * X coordinates to be off by a certain width...
 	 * 
 	 * @param item1
@@ -140,7 +147,5 @@
 
 		// Ensure the two items
-		if ((minX >= startX && minX <= endX)
-				|| (maxX >= startX && maxX <= endX)
-				|| (startX >= minX && startX <= maxX)
+		if ((minX >= startX && minX <= endX) || (maxX >= startX && maxX <= endX) || (startX >= minX && startX <= maxX)
 				|| (endX >= minX && endX <= maxX)) {
 			return true;
@@ -150,6 +155,5 @@
 	}
 
-	public static boolean sameBulletType(String bullet1, String bullet2)
-	{
+	public static boolean sameBulletType(String bullet1, String bullet2) {
 		if (bullet1 == null || bullet2 == null) {
 			return false;
@@ -160,11 +164,9 @@
 		}
 
-		if (Character.isLetter(bullet1.charAt(0))
-				&& Character.isLetter(bullet2.charAt(0))) {
+		if (Character.isLetter(bullet1.charAt(0)) && Character.isLetter(bullet2.charAt(0))) {
 			return true;
 		}
 
-		if (Character.isDigit(bullet1.charAt(0))
-				&& Character.isDigit(bullet2.charAt(0))) {
+		if (Character.isDigit(bullet1.charAt(0)) && Character.isDigit(bullet2.charAt(0))) {
 			return true;
 		}
@@ -205,11 +207,10 @@
 	 * @return
 	 */
-	public static int Align(List<Text> toAlign, boolean moveAll, int adjust,
-			List<Item> changedItems) {
+	public static int Align(List<Text> toAlign, boolean moveAll, int adjust, List<Item> changedItems) {
 		Collections.sort(toAlign);
 
 		/*
-		 * Single items dont need alignment But if there are two items we may
-		 * still want to format them... ie if they are too close together.
+		 * Single items dont need alignment But if there are two items we may still want
+		 * to format them... ie if they are too close together.
 		 */
 		if (toAlign.size() < 1) {
@@ -232,6 +233,5 @@
 			lastBullet = StandardGestureActions.getAutoBullet(above.getText());
 		} else {
-			lastBullet = StandardGestureActions.getBullet(toAlign.get(0)
-					.getText());
+			lastBullet = StandardGestureActions.getBullet(toAlign.get(0).getText());
 		}
 		if (needsRenumbering(lastBullet)) {
@@ -251,6 +251,5 @@
 
 					// if we changed the item, add to changedItems list
-					if (changedItems != null
-							&& oldText != currentText.getText()
+					if (changedItems != null && oldText != currentText.getText()
 							&& !changedItems.contains(currentText)) {
 						Item copy = currentText.copy();
@@ -293,6 +292,5 @@
 
 			if (UserSettings.FormatSpacingMax.get() != null) {
-				double maxSpace = UserSettings.FormatSpacingMax.get()
-						* above.getSize();
+				double maxSpace = UserSettings.FormatSpacingMax.get() * above.getSize();
 				if (maxSpace < space) {
 					space = (int) Math.round(maxSpace);
@@ -301,6 +299,5 @@
 
 			if (UserSettings.FormatSpacingMin.get() != null) {
-				double minSpace = UserSettings.FormatSpacingMin.get()
-						* above.getSize();
+				double minSpace = UserSettings.FormatSpacingMin.get() * above.getSize();
 				if (minSpace > space) {
 					space = (int) Math.round(minSpace);
@@ -309,14 +306,9 @@
 
 			// Need to do things differently for FORMAT than for DROPPING
-			if (moveAll && above != curr.getNameItem()
-					&& above != curr.getTitleItem()) {
+			if (moveAll && above != curr.getNameItem() && above != curr.getTitleItem()) {
 				x = above.getX();
-				int y = above.getBounds().getMaxY()
-						+ space
-						+ (from.getY() - from.getBounds().getMinY());
-
-				if (changedItems != null
-						&& (from.getX() != x || from.getY() != y)
-						&& !changedItems.contains(from)) {
+				int y = above.getBounds().getMaxY() + space + (from.getY() - from.getBounds().getMinY());
+
+				if (changedItems != null && (from.getX() != x || from.getY() != y) && !changedItems.contains(from)) {
 					Item copy = from.copy();
 					copy.setID(from.getID());
@@ -343,6 +335,5 @@
 			int newPos = bottom + space + diff;
 
-			if (changedItems != null
-					&& ((moveAll && current.getX() != x) || current.getY() != newPos)
+			if (changedItems != null && ((moveAll && current.getX() != x) || current.getY() != newPos)
 					&& !changedItems.contains(current)) {
 				Item copy = current.copy();
@@ -411,5 +402,6 @@
 			// next move
 			if (opposite.hasChanged() && opposite.equals(toSave)) {
-				if (EcosystemManager.getGraphicsManager().showDialog("Changes", "Leaving this frame will discard changes made in the " + side + " Frame. Continue?")) {
+				if (EcosystemManager.getGraphicsManager().showDialog("Changes",
+						"Leaving this frame will discard changes made in the " + side + " Frame. Continue?")) {
 					FrameIO.SaveFrame(toSave);
 					DisplayController.Reload(DisplayController.getSideFrameIsOn(opposite));
@@ -420,5 +412,6 @@
 			} else if (opposite.hasOverlay(toSave)) {
 				if (toSave.hasChanged()) {
-					if (EcosystemManager.getGraphicsManager().showDialog("Changes", "Leaving this frame will discard changes made in the " + side + " Frame. Continue?")) {
+					if (EcosystemManager.getGraphicsManager().showDialog("Changes",
+							"Leaving this frame will discard changes made in the " + side + " Frame. Continue?")) {
 						FrameIO.SaveFrame(toSave);
 						DisplayController.Reload(DisplayController.getSideFrameIsOn(opposite));
@@ -440,11 +433,10 @@
 	}
 
-	// TODO: consider reloating this method to Frame class?    
-	protected static Item getAnnotation(Frame frame, String annotationStr)
-	{
+	// TODO: consider reloating this method to Frame class?
+	protected static Item getAnnotation(Frame frame, String annotationStr) {
 		Item matched_item = null;
 
 		// check for an updated template...
-		for (Item i : frame.getAnnotationItems()) {				
+		for (Item i : frame.getAnnotationItems()) {
 
 			if (ItemUtils.startsWithTag(i, annotationStr)) {
@@ -458,42 +450,41 @@
 	}
 
-	protected static void doFrameTransition(Item frameTransition, Frame from, Frame to)
-	{
-		String s = frameTransition.getText();		
+	protected static void doFrameTransition(Item frameTransition, Frame from, Frame to) {
+		String s = frameTransition.getText();
 		String[] s_array = s.split(":");
-		if(s_array.length > 1){
+		if (s_array.length > 1) {
 			String slide_mode_method = s_array[1].trim();
-			
+
 			FrameTransition transition = new FrameTransition(from.getBuffer(), slide_mode_method);
-			
+
 			DisplayController.setTransition(from, transition);
-			
+
 			System.out.println("Triggered on annotation: " + s);
 		} else {
 			System.err.println("Warning: failed to detect frameTransition type");
-			// TODO: print list as a result of reflection listing	   
-		}
-	}				
+			// TODO: print list as a result of reflection listing
+		}
+	}
 
 	/**
 	 * Displays the given Frame on the display. If the current frame has changed
 	 * since the last save then it will be saved before the switch is made. The
-	 * caller can also dictate whether the current frame is added to the
-	 * back-stack or not.
+	 * caller can also dictate whether the current frame is added to the back-stack
+	 * or not.
 	 * 
 	 * @param toDisplay
 	 *            The Frame to display on the screen
 	 * @param addToBack
-	 *            True if the current Frame should be added to the back-stack,
-	 *            False otherwise
+	 *            True if the current Frame should be added to the back-stack, False
+	 *            otherwise
 	 */
-	public static void DisplayFrame(Frame toDisplay, boolean addToBack, boolean incrementStats)
-	{
+	public static void DisplayFrame(Frame toDisplay, boolean addToBack, boolean incrementStats) {
 		if (toDisplay == null) {
 			return;
 		}
-		
+
 		final PermissionPair framePermissions = toDisplay.getPermission();
-		if (framePermissions != null && framePermissions.getPermission(toDisplay.getOwner()) == UserAppliedPermission.denied) {
+		if (framePermissions != null
+				&& framePermissions.getPermission(toDisplay.getOwner()) == UserAppliedPermission.denied) {
 			MessageBay.errorMessage("Insufficient permissions to navigate to frame: " + toDisplay.getName());
 			return;
@@ -569,8 +560,9 @@
 			// Only need to worry about frame transitions when in Audience Mode
 
-			// Test to see if frame transition specified through annotation, and perform it if one if found
+			// Test to see if frame transition specified through annotation, and perform it
+			// if one if found
 			Item frameTransition = getAnnotation(toDisplay, "@frameTransition");
 			if (frameTransition != null) {
-				doFrameTransition(frameTransition,current,toDisplay);
+				doFrameTransition(frameTransition, current, toDisplay);
 			}
 		}
@@ -586,15 +578,14 @@
 
 	/**
-	 * Loads and displays the Frame with the given framename, and adds the
-	 * current frame to the back-stack if required.
+	 * Loads and displays the Frame with the given framename, and adds the current
+	 * frame to the back-stack if required.
 	 * 
 	 * @param framename
 	 *            The name of the Frame to load and display
 	 * @param addToBack
-	 *            True if the current Frame should be added to the back-stack,
-	 *            false otherwise
+	 *            True if the current Frame should be added to the back-stack, false
+	 *            otherwise
 	 */
-	public static void DisplayFrame(String frameName, boolean addToBack,
-			boolean incrementStats) {
+	public static void DisplayFrame(String frameName, boolean addToBack, boolean incrementStats) {
 		Frame newFrame = getFrame(frameName);
 
@@ -606,7 +597,7 @@
 
 	/**
-	 * Loads and displays the Frame with the given framename and adds the
-	 * current frame to the back-stack. This is the same as calling
-	 * DisplayFrame(framename, true)
+	 * Loads and displays the Frame with the given framename and adds the current
+	 * frame to the back-stack. This is the same as calling DisplayFrame(framename,
+	 * true)
 	 * 
 	 * @param framename
@@ -629,6 +620,6 @@
 
 	/**
-	 * Creates a new Picture Item from the given Text source Item and adds it to
-	 * the given Frame.
+	 * Creates a new Picture Item from the given Text source Item and adds it to the
+	 * given Frame.
 	 * 
 	 * @return True if the image was created successfully, false otherwise
@@ -647,6 +638,5 @@
 				// MessageBay.errorMessage("Expected image path after @i:");
 			} else {
-				MessageBay.errorMessage("Image " + imagePath
-						+ " could not be loaded");
+				MessageBay.errorMessage("Image " + imagePath + " could not be loaded");
 			}
 			return false;
@@ -658,6 +648,6 @@
 
 	/**
-	 * Creates an interactive widget and adds it to a frame. If txt has no
-	 * parent the parent will be set to frame.
+	 * Creates an interactive widget and adds it to a frame. If txt has no parent
+	 * the parent will be set to frame.
 	 * 
 	 * @param frame
@@ -713,8 +703,7 @@
 	}
 
-	public static List<String> ParseProfile(Frame profile)
-	{
+	public static List<String> ParseProfile(Frame profile) {
 		List<String> errors = new LinkedList<String>();
-		
+
 		if (profile == null) {
 			return errors;
@@ -722,6 +711,6 @@
 
 		/*
-		 * Make sure the correct cursor shows when turning off the custom cursor
-		 * and reparsing the profile frame
+		 * Make sure the correct cursor shows when turning off the custom cursor and
+		 * reparsing the profile frame
 		 */
 		FreeItems.getCursor().clear();
@@ -739,5 +728,5 @@
 					continue;
 				}
-				
+
 				String attribute = attributeFullCase.trim().toLowerCase().replaceAll("^@", "");
 
@@ -764,6 +753,5 @@
 	 * @param profile
 	 */
-	public static void loadFirstFrame(Frame profile)
-	{
+	public static void loadFirstFrame(Frame profile) {
 		if (UserSettings.HomeFrame.get() == null) {
 			UserSettings.HomeFrame.set(profile.getName());
@@ -781,6 +769,5 @@
 	}
 
-	public static Colour[] getColorWheel(Frame frame)
-	{
+	public static Colour[] getColorWheel(Frame frame) {
 		if (frame != null) {
 			List<Text> textItems = frame.getBodyTextItems(false);
@@ -797,6 +784,5 @@
 	}
 
-	public static String getLink(Item item, String alt)
-	{
+	public static String getLink(Item item, String alt) {
 		if (item == null || !(item instanceof Text)) {
 			return alt;
@@ -816,6 +802,5 @@
 	}
 
-	public static String getDir(String name)
-	{
+	public static String getDir(String name) {
 		if (name != null) {
 			File tester = new File(name);
@@ -833,6 +818,5 @@
 	}
 
-	public static ArrayList<String> getDirs(Item item)
-	{
+	public static ArrayList<String> getDirs(Item item) {
 		ArrayList<String> dirsToAdd = new ArrayList<String>();
 		String dirListFrameName = item.getAbsoluteLink();
@@ -857,16 +841,14 @@
 	}
 
-	public static void Parse(Frame toParse)
-	{
+	public static void Parse(Frame toParse) {
 		Parse(toParse, false);
 	}
 
 	/**
-	 * Checks for any special Annotation items and updates the display as
-	 * necessary. Special Items: Images, overlays, sort.
+	 * Checks for any special Annotation items and updates the display as necessary.
+	 * Special Items: Images, overlays, sort.
 	 * 
 	 */
-	public static void Parse(Frame toParse, boolean firstParse)
-	{
+	public static void Parse(Frame toParse, boolean firstParse) {
 		Parse(toParse, firstParse, false);
 	}
@@ -877,10 +859,9 @@
 	 * @param firstParse
 	 * @param ignoreAnnotations
-	 *            used to prevent infinate loops such as when performing TDFC
-	 *            with an ao tag linked to a frame with an frameImage of a frame
-	 *            which also has an ao tag on it.
+	 *            used to prevent infinate loops such as when performing TDFC with
+	 *            an ao tag linked to a frame with an frameImage of a frame which
+	 *            also has an ao tag on it.
 	 */
-	public static void Parse(Frame toParse, boolean firstParse, boolean ignoreAnnotations)
-	{
+	public static void Parse(Frame toParse, boolean firstParse, boolean ignoreAnnotations) {
 		// TODO check why we are getting toParse == null... when profile frame
 		// is being created and change the lines below
@@ -892,5 +873,5 @@
 			ItemUtils.EnclosedCheck(toParse.getItems());
 		}
-		
+
 		List<Item> items = toParse.getItems();
 
@@ -937,6 +918,6 @@
 		}
 
-		//DotType pointtype = DotType.square;
-		//boolean filledPoints = true;
+		// DotType pointtype = DotType.square;
+		// boolean filledPoints = true;
 
 		UserAppliedPermission permission = toParse.getUserAppliedPermission();
@@ -958,46 +939,38 @@
 							Text txt = (Text) i;
 							String line = txt.getFirstLine();
-							line = ItemUtils.StripTag(line,
-									ItemUtils.GetTag(ItemUtils.TAG_POINTTYPE));
+							line = ItemUtils.StripTag(line, ItemUtils.GetTag(ItemUtils.TAG_POINTTYPE));
 
 							if (line != null) {
 								line = line.toLowerCase();
 								if (line.indexOf(" ") > 0) {
-									String fill = line.substring(line
-											.indexOf(" ") + 1);
+									String fill = line.substring(line.indexOf(" ") + 1);
 									if (fill.startsWith("nofill")) {
-										//filledPoints = false;
+										// filledPoints = false;
 									} else {
-										//filledPoints = true;
+										// filledPoints = true;
 									}
 								}
 
 								if (line.startsWith("circle")) {
-									//pointtype = DotType.circle;
+									// pointtype = DotType.circle;
 								} else {
-									//pointtype = DotType.square;
+									// pointtype = DotType.square;
 								}
 							}
-						}// check for new VECTOR items
-						else if (!DisplayController.isXRayMode()
-								&& ItemUtils.startsWithTag(i,
-										ItemUtils.TAG_VECTOR)
+						} // check for new VECTOR items
+						else if (!DisplayController.isXRayMode() && ItemUtils.startsWithTag(i, ItemUtils.TAG_VECTOR)
 								&& i.getLink() != null) {
 							if (!i.getAbsoluteLink().equals(toParse.getName())) {
-								addVector(vectors, UserAppliedPermission.none,
-										permission, i);
+								addVector(vectors, UserAppliedPermission.none, permission, i);
 							}
 						} else if (!DisplayController.isXRayMode()
-								&& ItemUtils.startsWithTag(i,
-										ItemUtils.TAG_ACTIVE_VECTOR)
-								&& i.getLink() != null) {
+								&& ItemUtils.startsWithTag(i, ItemUtils.TAG_ACTIVE_VECTOR) && i.getLink() != null) {
 							if (!i.getAbsoluteLink().equals(toParse.getName())) {
-								addVector(vectors,
-										UserAppliedPermission.followLinks,
-										permission, i);
+								addVector(vectors, UserAppliedPermission.followLinks, permission, i);
 							}
 						}
 						// check for new OVERLAY items
-						else if (!ignoreAnnotations && ItemUtils.startsWithTag(i, ItemUtils.TAG_OVERLAY) && i.getLink() != null) {
+						else if (!ignoreAnnotations && ItemUtils.startsWithTag(i, ItemUtils.TAG_OVERLAY)
+								&& i.getLink() != null) {
 							if (i.getAbsoluteLink().equalsIgnoreCase(toParse.getName())) {
 								// This frame contains an active overlay which
@@ -1014,7 +987,5 @@
 						}
 						// check for ACTIVE_OVERLAY items
-						else if (!ignoreAnnotations
-								&& ItemUtils.startsWithTag(i,
-										ItemUtils.TAG_ACTIVE_OVERLAY)
+						else if (!ignoreAnnotations && ItemUtils.startsWithTag(i, ItemUtils.TAG_ACTIVE_OVERLAY)
 								&& i.getLink() != null) {
 							String link = i.getAbsoluteLink();
@@ -1022,7 +993,5 @@
 								// This frame contains an active overlay which
 								// points to itself
-								MessageBay
-								.errorMessage(toParse.getName()
-										+ " contains an @ao which links to itself");
+								MessageBay.errorMessage(toParse.getName() + " contains an @ao which links to itself");
 								continue;
 							}
@@ -1032,6 +1001,5 @@
 							if (current != null) {
 								for (Overlay o : current.getOverlays()) {
-									if (o.Frame.getName()
-											.equalsIgnoreCase(link)) {
+									if (o.Frame.getName().equalsIgnoreCase(link)) {
 										overlayFrame = o.Frame;
 									}
@@ -1043,26 +1011,20 @@
 
 							// get level if specified
-							String level = new AttributeValuePair(i.getText())
-									.getValue();
+							String level = new AttributeValuePair(i.getText()).getValue();
 							// default permission (if none is specified)
-							PermissionPair permissionLevel = new PermissionPair(
-									level, UserAppliedPermission.followLinks);
+							PermissionPair permissionLevel = new PermissionPair(level,
+									UserAppliedPermission.followLinks);
 
 							if (overlayFrame != null) {
-								Overlay existingOverlay = Overlay.getOverlay(
-										overlays, overlayFrame);
+								Overlay existingOverlay = Overlay.getOverlay(overlays, overlayFrame);
 								// If it wasn't in the list create it and add
 								// it.
 								if (existingOverlay == null) {
-									Overlay newOverlay = new Overlay(
-											overlayFrame,
-											permissionLevel
-											.getPermission(overlayFrame
-													.getOwner()));
+									Overlay newOverlay = new Overlay(overlayFrame,
+											permissionLevel.getPermission(overlayFrame.getOwner()));
 									i.setOverlay(newOverlay);
 									overlays.add(newOverlay);
 								} else {
-									existingOverlay.Frame
-									.setPermission(permissionLevel);
+									existingOverlay.Frame.setPermission(permissionLevel);
 								}
 							}
@@ -1071,16 +1033,11 @@
 						else {
 							if (!DisplayController.isXRayMode()) {
-								if (ItemUtils.startsWithTag(i,
-										ItemUtils.TAG_IMAGE, true)) {
+								if (ItemUtils.startsWithTag(i, ItemUtils.TAG_IMAGE, true)) {
 									if (!i.hasEnclosures()) {
 										createPicture(toParse, (Text) i);
 									}
 									// check for frame images
-								} else if (ItemUtils.startsWithTag(i,
-										ItemUtils.TAG_FRAME_IMAGE)
-										&& i.getLink() != null
-										&& !i.getAbsoluteLink()
-										.equalsIgnoreCase(
-												toParse.getName())) {
+								} else if (ItemUtils.startsWithTag(i, ItemUtils.TAG_FRAME_IMAGE) && i.getLink() != null
+										&& !i.getAbsoluteLink().equalsIgnoreCase(toParse.getName())) {
 									XRayable image = null;
 									if (i.hasEnclosures()) {
@@ -1095,10 +1052,6 @@
 									// FrameImage
 									toParse.addItem(image);
-								} else if (ItemUtils.startsWithTag(i,
-										ItemUtils.TAG_BITMAP_IMAGE)
-										&& i.getLink() != null
-										&& !i.getAbsoluteLink()
-										.equalsIgnoreCase(
-												toParse.getName())) {
+								} else if (ItemUtils.startsWithTag(i, ItemUtils.TAG_BITMAP_IMAGE) && i.getLink() != null
+										&& !i.getAbsoluteLink().equalsIgnoreCase(toParse.getName())) {
 									XRayable image = null;
 									if (i.hasEnclosures()) {
@@ -1116,10 +1069,9 @@
 								} else if (ItemUtils.startsWithTag(i, "@c")) {
 									// Can only have a @c
-									if (!i.hasEnclosures()
-											&& i.getLines().size() == 1) {
+									if (!i.hasEnclosures() && i.getLines().size() == 1) {
 										toParse.addItem(new Circle((Text) i));
 									}
 									// Check for JSItem
-								} else if(ItemUtils.startsWithTag(i, "@js")) {
+								} else if (ItemUtils.startsWithTag(i, "@js")) {
 									toParse.addItem(new JSItem((Text) i));
 									// Check for interactive widgets
@@ -1138,7 +1090,6 @@
 				Logger.Log(e);
 				e.printStackTrace();
-				MessageBay.warningMessage("Exception occured when loading "
-						+ i.getClass().getSimpleName() + "(ID: " + i.getID()
-						+ ") " + e.getMessage() != null ? e.getMessage() : "");
+				MessageBay.warningMessage("Exception occured when loading " + i.getClass().getSimpleName() + "(ID: "
+						+ i.getID() + ") " + e.getMessage() != null ? e.getMessage() : "");
 			}
 		}
@@ -1146,6 +1097,5 @@
 		/*
 		 * for (Item i : items) { if (i instanceof Dot) { ((Dot)
-		 * i).setPointType(pointtype); ((Dot) i).useFilledPoints(filledPoints);
-		 * } }
+		 * i).setPointType(pointtype); ((Dot) i).useFilledPoints(filledPoints); } }
 		 */
 
@@ -1166,6 +1116,6 @@
 	 * @param i
 	 */
-	private static void addVector(List<Vector> vectors, UserAppliedPermission defaultPermission, UserAppliedPermission framePermission, Item i)
-	{
+	private static void addVector(List<Vector> vectors, UserAppliedPermission defaultPermission,
+			UserAppliedPermission framePermission, Item i) {
 		// TODO It is possible to get into an infinite loop if a
 		// frame contains an @ao which leads to a frame with an
@@ -1174,9 +1124,10 @@
 
 		// Get the permission from off the vector frame
-		UserAppliedPermission vectorPermission = UserAppliedPermission.getPermission(vector.getAnnotationValue("permission"), defaultPermission);
-		
+		UserAppliedPermission vectorPermission = UserAppliedPermission
+				.getPermission(vector.getAnnotationValue("permission"), defaultPermission);
+
 		// If the frame permission is lower, use that
 		vectorPermission = UserAppliedPermission.min(vectorPermission, framePermission);
-		
+
 		// Highest permissable permission for vectors is copy
 		vectorPermission = UserAppliedPermission.min(vectorPermission, UserAppliedPermission.copy);
@@ -1195,12 +1146,11 @@
 	}
 
-	public static Item onItem(float floatX, float floatY, boolean changeLastEdited)
-	{
+	public static Item onItem(float floatX, float floatY, boolean changeLastEdited) {
 		return onItem(DisplayController.getCurrentFrame(), floatX, floatY, changeLastEdited);
 	}
 
 	/**
-	 * Searches through the list of items on this frame to find one at the given
-	 * x,y coordinates.
+	 * Searches through the list of items on this frame to find one at the given x,y
+	 * coordinates.
 	 * 
 	 * @param x
@@ -1255,9 +1205,7 @@
 		} else {
 			if (LastEdited != null) {
-				if (LastEdited.contains(x, y)
-						&& !FreeItems.getInstance().contains(LastEdited)
+				if (LastEdited.contains(x, y) && !FreeItems.getInstance().contains(LastEdited)
 						&& LastEdited.getParent() == DisplayController.getCurrentFrame()
-						&& LastEdited.getParent().getItems().contains(LastEdited))
-				{
+						&& LastEdited.getParent().getItems().contains(LastEdited)) {
 					LastEdited.setOverlayPermission(UserAppliedPermission.full);
 					return LastEdited;
@@ -1273,5 +1221,6 @@
 
 				// do not check annotation items in audience mode
-				//TODO: Upon hover of Rubbish Bin, Undo and Restore Widgets, flickering occurs depending on the mouse distance from a corner. Resolve this.
+				// TODO: Upon hover of Rubbish Bin, Undo and Restore Widgets, flickering occurs
+				// depending on the mouse distance from a corner. Resolve this.
 				if (i.isVisible() && !(DisplayController.isAudienceMode() && i.isAnnotation())) {
 					if (i instanceof WidgetCorner) {
@@ -1283,18 +1232,17 @@
 								Widget iw = wc.getWidgetSource();
 
-								if(iw.getBounds().contains(x, y)){
-
-									if( !FreeItems.getInstance().contains(i))
-									{
-										possibles.add(i);					    		
+								if (iw.getBounds().contains(x, y)) {
+
+									if (!FreeItems.getInstance().contains(i)) {
+										possibles.add(i);
 									}
-								}	
+								}
 							}
 						}
 					}
 
-					if (i.contains(new Point(x, y))){
-						if(!FreeItems.getInstance().contains(i)) {
-							possibles.add(i);		    		
+					if (i.contains(new Point(x, y))) {
+						if (!FreeItems.getInstance().contains(i)) {
+							possibles.add(i);
 						}
 					}
@@ -1316,11 +1264,10 @@
 		// return closest x,y pair to mouse
 		Item closest = possibles.get(0);
-		int distance = (int) Math.round(Math.sqrt(Math.pow(
-				Math.abs(closest.getX() - x), 2)
-				+ Math.pow(Math.abs(closest.getY() - y), 2)));
+		int distance = (int) Math.round(
+				Math.sqrt(Math.pow(Math.abs(closest.getX() - x), 2) + Math.pow(Math.abs(closest.getY() - y), 2)));
 
 		for (Item i : possibles) {
-			int d = (int) Math.round(Math.sqrt(Math.pow(Math.abs(i.getX() - x),
-					2) + Math.pow(Math.abs(i.getY() - y), 2)));
+			int d = (int) Math
+					.round(Math.sqrt(Math.pow(Math.abs(i.getX() - x), 2) + Math.pow(Math.abs(i.getY() - y), 2)));
 
 			// System.out.println(d);
@@ -1336,29 +1283,26 @@
 			}
 
-		}	
+		}
 
 		return closest;
 	}
-	
+
 	/**
 	 * Checks if the mouse is currently over an item.
 	 * 
-	 * @return
-	 * 		True if the mouse is over any item, false otherwise.
+	 * @return True if the mouse is over any item, false otherwise.
 	 */
-	public static boolean hasCurrentItem()
-	{
+	public static boolean hasCurrentItem() {
 		return getCurrentItem() != null;
 	}
 
-	public synchronized static Item getCurrentItem()
-	{
-		return onItem(DisplayController.getCurrentFrame(), DisplayController.getMouseX(), DisplayController.getMouseY(), true);
-	}
-
-	public static PolygonBounds getEnlosingPolygon()
-	{
+	public synchronized static Item getCurrentItem() {
+		return onItem(DisplayController.getCurrentFrame(), DisplayController.getMouseX(), DisplayController.getMouseY(),
+				true);
+	}
+
+	public static PolygonBounds getEnlosingPolygon() {
 		Collection<Item> enclosure = getEnclosingLineEnds();
-		
+
 		if (enclosure == null || enclosure.size() == 0) {
 			return null;
@@ -1373,13 +1317,11 @@
 	 * @return
 	 */
-	public static Collection<Item> getCurrentItems()
-	{
+	public static Collection<Item> getCurrentItems() {
 		return getCurrentItems(getCurrentItem());
 	}
 
-	public static Collection<Item> getCurrentItems(Item currentItem)
-	{
+	public static Collection<Item> getCurrentItems(Item currentItem) {
 		Collection<Item> enclosure = getEnclosingLineEnds();
-		
+
 		if (enclosure == null || enclosure.size() == 0) {
 			return null;
@@ -1388,11 +1330,11 @@
 		Item firstItem = enclosure.iterator().next();
 
-		Collection<Item> enclosed = getItemsEnclosedBy(DisplayController.getCurrentFrame(), firstItem.getEnclosedShape());
+		Collection<Item> enclosed = getItemsEnclosedBy(DisplayController.getCurrentFrame(),
+				firstItem.getEnclosedShape());
 
 		// Brook: enclosed widgets are to be fully enclosed, never partially
 		/*
-		 * MIKE says: but doesn't this mean that widgets are treated differently
-		 * from ALL other object which only need to be partially enclosed to be
-		 * picked up
+		 * MIKE says: but doesn't this mean that widgets are treated differently from
+		 * ALL other object which only need to be partially enclosed to be picked up
 		 */
 		List<Widget> enclosedWidgets = new LinkedList<Widget>();
@@ -1412,5 +1354,5 @@
 				}
 			}
-			
+
 			if (i instanceof WidgetCorner) {
 				if (!enclosedWidgets.contains(((WidgetCorner) i).getWidgetSource())) {
@@ -1418,5 +1360,5 @@
 				}
 			}
-			
+
 			i.setHighlightMode(Item.HighlightMode.None);
 			i.setHighlightColorToDefault();
@@ -1435,16 +1377,16 @@
 
 	/**
-	 * Gets the collection of Dot items that form the enclosure nearest to the current mouse position.
+	 * Gets the collection of Dot items that form the enclosure nearest to the
+	 * current mouse position.
 	 */
-	public static Collection<Item> getEnclosingLineEnds()
-	{
+	public static Collection<Item> getEnclosingLineEnds() {
 		return getEnclosingLineEnds(new Point(DisplayController.getMouseX(), DisplayController.getMouseY()));
 	}
 
 	/**
-	 * Gets the collection of Dot items that form the enclosure nearest to the given position.
+	 * Gets the collection of Dot items that form the enclosure nearest to the given
+	 * position.
 	 */
-	public static Collection<Item> getEnclosingLineEnds(Point position)
-	{
+	public static Collection<Item> getEnclosingLineEnds(Point position) {
 		// update enclosed shapes
 		Frame current = DisplayController.getCurrentFrame();
@@ -1484,5 +1426,5 @@
 		if (used.size() == 1) {
 			return used.get(0).getEnclosingDots();
-		// otherwise, determine which polygon is closest to the cursor
+			// otherwise, determine which polygon is closest to the cursor
 		} else {
 			Collections.sort(used, new Comparator<Item>() {
@@ -1503,5 +1445,5 @@
 
 						if (i < p2.getPointCount()) {
-							diff2 = Math.abs(p2.getPoint(i).getX() - mouseX)  + Math.abs(p2.getPoint(i).getY() - mouseY);
+							diff2 = Math.abs(p2.getPoint(i).getX() - mouseX) + Math.abs(p2.getPoint(i).getY() - mouseY);
 						}
 
